<?php

class CheckMonitoringData extends SimpleORMap
{
    static protected function configure($config = array())
    {
        $config['db_table'] = 'check_monitoring_data';
        $config['belongs_to']['server'] = [
            'class_name'  => CheckRemoteServer::class,
            'foreign_key' => 'server_id',
        ];
        $config['additional_fields'] = [
            'previous' => [
                'get' => function (CheckMonitoringData $data) {
                    return static::findOneBySQL('`server_id` = :server_id AND `mkdate` < :mkdate ORDER BY `mkdate` DESC LIMIT 1', [
                        'server_id' => $data['server_id'],
                        'mkdate' => $data['mkdate']
                    ]);
                }
            ],
            'next' => [
                'get' => function (CheckMonitoringData $data) {
                    return static::findOneBySQL('`server_id` = :server_id AND `mkdate` > :mkdate ORDER BY `mkdate` ASC LIMIT 1', [
                        'server_id' => $data['server_id'],
                        'mkdate' => $data['mkdate']
                    ]);
                }
            ]
        ];
        parent::configure($config);
    }

    static public function findHighest($server_id, $key)
    {
        return self::findOneBySQL('server_id = :server_id ORDER BY `'.$key.'` DESC, mkdate DESC LIMIT 1', [
            'server_id' => $server_id
        ]);
    }
}
