<?php

class CheckRemoteServer extends SimpleORMap
{
    static protected function configure($config = array())
    {
        $config['db_table'] = 'check_remote_servers';
        $config['has_many']['alarms'] = [
            'class_name'  => CheckRemoteServerAlarm::class,
            'foreign_key' => 'server_id',
            'on_delete' => 'delete',
            'on_store' => 'store'
        ];
        parent::configure($config);
    }

    public function fetch()
    {
        if ($this['url']) {
            $time1 = microtime(true);
            $r = curl_init();
            curl_setopt($r, CURLOPT_URL, $this['url']);
            curl_setopt($r, CURLOPT_RETURNTRANSFER, TRUE);
            curl_setopt($r, CURLOPT_FOLLOWLOCATION, true);
            if (!$this['ssl']) {
                curl_setopt($r, CURLOPT_SSL_VERIFYPEER, false);
                curl_setopt($r, CURLOPT_SSL_VERIFYHOST, false);
            }
            $contents = curl_exec($r);
            $error = curl_error($r);
            curl_close($r);
            $time2 = microtime(true);
            if ($contents) {
                $contents = json_decode($contents, true);
                $contents['success'] = true;
                $contents['request_time'] = round($time2 - $time1, 3);
            } else {
                $contents = [
                    'success' => false,
                    'request_time' => round($time2 - $time1, 3),
                    'error' => $error
                ];
            }
        } else {
            $contents = [
                'success' => false,
                'request_time' => 0
            ];
        }
        return $contents;
    }

    public function requestData($multi_curl)
    {
        $r = curl_init(); // init curl, and then setup your options
        curl_setopt($r, CURLOPT_URL, $this['url']);
        curl_setopt($r, CURLOPT_RETURNTRANSFER,true); // returns the result - very important
        curl_setopt($r, CURLOPT_HEADER, 0); // no headers in the output
        if (!$this['ssl']) {
            curl_setopt($r, CURLOPT_SSL_VERIFYPEER, false);
            curl_setopt($r, CURLOPT_SSL_VERIFYHOST, false);
        }
        curl_multi_add_handle($multi_curl, $r);
        return [
            'request' => $r,
            'server' => $this
        ];
    }

}
