<?php

namespace CheckStudip;

class Cache implements \CheckStudipMetric
{
    public function getName()
    {
        return _('Cache');
    }

    public function getDescription()
    {
        return null;
    }

    public function getIndex()
    {
        return 'cache';
    }

    public function measure()
    {
        $currentCache = \Config::get()->SYSTEMCACHE;
        $currentCacheClass = \CacheType::findOneByClass_name($currentCache['type']);
        return $GLOBALS['CACHING_ENABLE'] ? $currentCacheClass->class_name : 'no';
    }

    public function defaultAlarm()
    {
        return [
            'type' => 'warning',
            'compare' => '=',
            'value' => 'no'
        ];
    }

    public function getMessage()
    {
        return _('Cache ist falsch konfiguriert.');
    }
}
