<?php

namespace CheckStudip;

class FailedSoapRequests implements \CheckStudipMetric
{
    public function getName()
    {
        return _('Fehlgeschlagene SOAP-Aufrufe');
    }

    public function getDescription()
    {
        return _('Dieser Wert sollte immer leer sein. Nur dann ist alles in Ordnung. Ein typischer SOAP-Aufruf wäre zum Beispiel ein Abruf von Evasys-Fragebögen aus dem Evasys.');
    }

    public function getIndex()
    {
        return 'failed_soap_requests';
    }

    public function measure()
    {
        $failed_soap_requests = [];
        foreach (\CheckSoapRequest::findBySQL('necessary_request = 1') as $request) {
            $output2 = $request->execute();
            if ($output2['error']) {
                $failed_soap_requests[] = $request->name;
            }
        }
        return implode("\n", $failed_soap_requests);
    }

    public function defaultAlarm()
    {
        return [
            'type' => 'error',
            'compare' => '!=',
            'value' => ''
        ];
    }

    public function getMessage()
    {
        return _('Wichtige SOAP-Aufrufe funktionieren nicht.');
    }
}
