<?php

namespace CheckStudip;

class FreeSpaceData implements \CheckStudipMetric
{
    public function getName()
    {
        return _('Speicherplatz im Data-Verzeichnis');
    }

    public function getDescription()
    {
        return null;
    }

    public function getIndex()
    {
        return 'free_space_data';
    }

    public function measure()
    {
        return \disk_free_space($GLOBALS['UPLOAD_PATH']);
    }

    public function defaultAlarm()
    {
        return [
            'type' => 'warning',
            'compare' => '<=',
            'value' => 1024 * 1024 * 1024 * 5
        ];
    }

    public function getMessage()
    {
        return _('Data-Verzeichnis hat zu wenig freien Speicherplatz.');
    }
}
