<?php

namespace CheckStudip;

class FreeSpaceTmp implements \CheckStudipMetric
{
    public function getName()
    {
        return _('Speicherplatz im TMP-Ordner');
    }

    public function getDescription()
    {
        return null;
    }

    public function getIndex()
    {
        return 'free_space_tmp';
    }

    public function measure()
    {
        return \disk_free_space($GLOBALS['TMP_PATH']);
    }

    public function defaultAlarm()
    {
        return [
            'type' => 'warning',
            'compare' => '<=',
            'value' => 1024 * 1024 * 1024 * 2
        ];
    }

    public function getMessage()
    {
        return _('TMP-Ordner hat zu wenig freien Speicherplatz.');
    }
}
