<?php

namespace CheckStudip;

class InternetAccess implements \CheckStudipMetric
{
    public function getName()
    {
        return _('Verbindung zum Internet');
    }

    public function getDescription()
    {
        return null;
    }

    public function getIndex()
    {
        return 'internet_access';
    }

    public function measure()
    {
        ini_set('default_socket_timeout', 2);
        $success = @\file_get_contents(
            "https://develop.studip.de",
            FALSE ,
            NULL,
            0 ,
            10
        );
        if ($success === false) {
            $success = @\file_get_contents(
                "https://www.google.de",
                FALSE ,
                NULL,
                0 ,
                10
            );
            if ($success === false) {
                return 0;
            } else {
                return 1;
            }
        } else {
            return 1;
        }
    }

    public function defaultAlarm()
    {
        return [
            'compare' => '=',
            'value' => 0,
            'type' => 'warning'
        ];
    }

    public function getMessage()
    {
        return _('Kein Zugriff auf das Internet.');
    }
}
