<?php

namespace CheckStudip;

class LoadPercentage implements \CheckStudipMetric
{
    public function getName()
    {
        return _('Prozentuale Auslastung CPUs');
    }

    public function getDescription()
    {
        return _('Es wird der CPU-Load durch die Anzahl der Kerne in Prozent (0-100) angegeben. In manchen Fällen kann dieser Wert auch größer als 100 sein. Werte nahe oder über 100 bedeuten nicht, dass Stud.IP stillsteht, aber sie sind ein deutlicher Stressindikator.');
    }

    public function getIndex()
    {
        return 'load_percentage';
    }

    public function measure()
    {
        $load = \sys_getloadavg();
        return round($load[1] / \CheckStudip::getNumberOfCPUs(), 3) * 100;
    }

    public function defaultAlarm()
    {
        return [
            'compare' => '>=',
            'value' => 80,
            'type' => 'warning'
        ];
    }

    public function getMessage()
    {
        return _('Die CPU ist hoch ausgelastet.');
    }
}
