<?php

namespace CheckStudip;

class MailserverConnection implements \CheckStudipMetric
{
    public function getName()
    {
        return _('Verbindung zum Mailserver');
    }

    public function getDescription()
    {
        return null;
    }

    public function getIndex()
    {
        return 'mailserver_connection';
    }

    public function measure()
    {
        if ($GLOBALS['MAIL_HOST_NAME'] && $GLOBALS['MAIL_TRANSPORT'] === "smtp") {
            $f = @\fsockopen($GLOBALS['MAIL_HOST_NAME'], $GLOBALS['MAIL_SMTP_OPTIONS']['port']);
            if ($f !== false) {
                $res = \fread($f, 1024);
                if ($f !== false && \strlen($res) > 0 && \strpos($res, '220') === 0) {
                    $output = 1;
                } else {
                    $output = 0;
                }
                if ($f !== false) {
                    @\fclose($f);
                }
            } else {
                $output = 0;
            }

            return $output;
        } else {
            return 0;
        }
    }

    public function defaultAlarm()
    {
        return [
            'type' => 'warning',
            'compare' => '=',
            'value' => 'no'
        ];
    }

    public function getMessage()
    {
        return _('Cache ist falsch konfiguriert.');
    }
}
