<?php

namespace CheckStudip;

class Plugins implements \CheckStudipMetric
{
    public function getName()
    {
        return _('Plugins');
    }

    public function getIndex()
    {
        return 'plugins';
    }

    public function getDescription()
    {
        return _('Es werden nicht alle installierten Plugins angezeigt, sondern nur die, die auch aktiviert sind.');
    }

    public function measure()
    {
        $statement = \DBManager::get()->prepare("
            SELECT `pluginclassname` FROM `plugins` WHERE `enabled` = 'yes'
        ");
        $statement->execute();
        $plugins = $statement->fetchAll(\PDO::FETCH_COLUMN, 0);
        sort($plugins);
        $plugins = array_map(function ($pluginclass) {
            $plugin = \PluginManager::getInstance()->getPlugin($pluginclass);

            if ($plugin && $plugin->getPluginVersion()) {
                $pluginclass .= ' '.$plugin->getPluginVersion();
            }
            return $pluginclass;
        }, $plugins);
        return implode(', ', $plugins);
    }

    public function defaultAlarm()
    {
        return null;
    }

    public function getMessage()
    {
        return '';
    }
}
