<?php
class AddExpiring extends Migration
{
	function up()
    {
        DBManager::get()->exec("
            ALTER TABLE `check_remote_servers`
            ADD COLUMN `expire_days` int(11) DEFAULT 365 AFTER `url`
        ");
        DBManager::get()->exec("
            ALTER TABLE `check_monitoring_data`
            ADD COLUMN `users_online` int(11) DEFAULT null AFTER `server_id`,
            ADD COLUMN `success` tinyint(1) DEFAULT '1' AFTER `users_online`,
            ADD COLUMN `load` double DEFAULT NULL AFTER `success`,
            ADD COLUMN `free_space_data` bigint DEFAULT null AFTER `load`,
            ADD COLUMN `free_space_tmp` bigint DEFAULT null AFTER `free_space_data`,
            ADD COLUMN `seminar_user_request_time` double DEFAULT NULL AFTER `free_space_tmp`,
            ADD COLUMN `request_time` double DEFAULT NULL AFTER `seminar_user_request_time`

        ");
        $statement = DBManager::get()->prepare("
            SELECT *
            FROM `check_monitoring_data`
        ");
        $statement->execute();
        $update = DBManager::get()->prepare("
            UPDATE TABLE `check_monitoring_data`
            SET `users_online` = :users_online,
                `success` = :success,
                `load` = :load,
                `free_space_data` = :free_space_data,
                `free_space_tmp` = :free_space_tmp,
                `seminar_user_request_time` = :seminar_user_request_time,
                `request_time` = :request_time
            WHERE `id` = :id
        ");
        while ($row = $statement->fetch(PDO::FETCH_ASSOC)) {
            $json = json_decode($row['json'], true);
            $update->execute([
                'id' => $row['id'],
                'users_online' => $json['users_online'] ?? null,
                'success' => $json['success'] ?? 0,
                'load' => $json['load'] ?? null,
                'free_space_data' => $json['free_space_data'] ?? null,
                'free_space_tmp' => $json['free_space_tmp'] ?? null,
                'seminar_user_request_time' => $json['seminar_user_request_time'],
                'request_time' => $json['request_time']
            ]);
        }
        DBManager::get()->exec("
            ALTER TABLE `check_monitoring_data`
            DROP COLUMN `json`
        ");
        SimpleORMap::expireTableScheme();
	}

    function down()
    {
        DBManager::get()->exec("
            ALTER TABLE`check_remote_servers`
            DROP COLUMN `expire_days`
        ");
        DBManager::get()->exec("
            ALTER TABLE`check_monitoring_data`
            DROP COLUMN `users_online`,
            DROP COLUMN `success`,
            DROP COLUMN `load`,
            DROP COLUMN `free_space_data`,
            DROP COLUMN `free_space_tmp`,
            DROP COLUMN `seminar_user_request_time`,
            DROP COLUMN `request_time`,
            ADD COLUMN `json` text DEFAULT NULL AFTER `server_id`
        ");
        DBManager::get()->exec("
            TRUNCATE TABLE`check_remote_servers`
        ");
    }
}
