<?php
class AddSoapRequests extends Migration
{
	function up()
    {
        DBManager::get()->exec("
        CREATE TABLE `check_soap_requests` (
            `request_id` char(32) NOT NULL,
            `name` varchar(64) NOT NULL,
            `wsdl` varchar(256) NOT NULL,
            `method` varchar(100) NOT NULL,
            `username` varchar(100) DEFAULT NULL,
            `password` varchar(100) DEFAULT NULL,
            `params` text DEFAULT NULL,
            `necessary_request` tinyint(1) DEFAULT NULL,
            `chdate` int(11) DEFAULT NULL,
            `mkdate` int(11) DEFAULT NULL,
            PRIMARY KEY (`request_id`)
        ) ENGINE=InnoDB
        ");
        DBManager::get()->exec("
            ALTER TABLE `check_monitoring_data`
            ADD COLUMN `mailserver_connection` tinyint(1) DEFAULT NULL AFTER `nonwritable_folders`,
            ADD COLUMN `failed_soap_requests` text DEFAULT NULL AFTER `mailserver_connection`
        ");

        $insert_request = DBManager::get()->prepare('
            INSERT INTO `check_soap_requests`
            SET `request_id` = :request_id,
                `name` = :name,
                `wsdl` = :wsdl,
                `method` = :method,
                `username` = :username,
                `password` = :password,
                `params` = :params,
                `necessary_request` = 1,
                `chdate` = UNIX_TIMESTAMP(),
                `mkdate` = UNIX_TIMESTAMP()
        ');
        if (Config::get()->EVASYS_WSDL && Config::get()->EVASYS_USER && Config::get()->EVASYS_PASSWORD) {
            $insert_request->execute([
                'request_id' => md5(uniqid()),
                'name' => 'Evasys-Fragebögen',
                'wsdl' => Config::get()->EVASYS_WSDL,
                'method' => 'GetFormsInfoByParams',
                'username' => Config::get()->EVASYS_USER,
                'password' => Config::get()->EVASYS_PASSWORD,
                'params' => '{"Params":{"Users":["1"],"IncludeDeactivatedForms":false,"SelectFields":["ShortName","Description"]}}'
            ]);
        }
        SimpleORMap::expireTableScheme();
	}

    function down()
    {
        DBManager::get()->exec("DROP TABLE `check_soap_requests`");
        DBManager::get()->exec("
            ALTER TABLE `check_monitoring_data`
            DROP COLUMN `mailserver_connection`,
            DROP COLUMN `failed_soap_requests`
        ");
        SimpleORMap::expireTableScheme();
    }
}
