<?php
class AddMonitoringPoints extends Migration
{
	function up()
    {
        DBManager::get()->exec("
            CREATE TABLE `check_monitoring_points` (
                `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
                `planned_time` int(11) NOT NULL,
                `mkdate` int(11) NOT NULL,
                PRIMARY KEY (`id`),
                UNIQUE KEY `planned_time` (`planned_time`)
            )
        ");
        DBManager::get()->exec("
            INSERT IGNORE INTO `check_monitoring_points`
                (`planned_time`, `mkdate`)
            SELECT ROUND(`mkdate` / 600) * 600, UNIX_TIMESTAMP()
            FROM `check_monitoring_data`
            GROUP BY ROUND(`mkdate` / 600) * 600
            ORDER BY `mkdate` ASC
        ");
        DBManager::get()->exec("
            ALTER TABLE `check_monitoring_data`
            ADD COLUMN `checkpoint_id` int(11) DEFAULT NULL AFTER `server_id`,
            ADD KEY `checkpoint_id` (`checkpoint_id`)
        ");

        DBManager::get()->exec("
            DELETE FROM `check_monitoring_data`
            WHERE `check_monitoring_data`.`mkdate` < UNIX_TIMESTAMP() - 86400 * 7
        ");
        DBManager::get()->exec("
            UPDATE `check_monitoring_data`
            SET `checkpoint_id` = (
                SELECT `check_monitoring_points`.`id`
                FROM `check_monitoring_points`
                WHERE `check_monitoring_points`.`planned_time` > `check_monitoring_data`.`mkdate` - 300
                    AND `check_monitoring_points`.`planned_time` <= `check_monitoring_data`.`mkdate` + 300
                LIMIT 1
            )
        ");
        DBManager::get()->exec("
            ALTER TABLE `check_remote_servers`
            ADD COLUMN `ssl` tinyint(1) DEFAULT '1' AFTER `expire_days`
        ");
        SimpleORMap::expireTableScheme();
	}

    function down()
    {
        DBManager::get()->exec("
            ALTER TABLE `check_remote_servers`
            DROP COLUMN `ssl`
        ");
        DBManager::get()->exec("
            ALTER TABLE `check_monitoring_data`
            DROP KEY `checkpoint_id` (`checkpoint_id`)
        ");
        DBManager::get()->exec("
            ALTER TABLE `check_monitoring_data`
            DROP COLUMN `checkpoint_id`
        ");
        DBManager::get()->exec("DROP TABLE `check_monitoring_points`");
        SimpleORMap::expireTableScheme();
    }
}
