<?php
class AddCacheCheck extends Migration
{
	function up()
    {
        DBManager::get()->exec("
            ALTER TABLE `check_monitoring_data`
            ADD COLUMN `cache` varchar(40) DEFAULT NULL AFTER `failed_soap_requests`
        ");
        $alarms = [
            [
                'metric' => 'cache',
                'compare' => '=',
                'value' => 'no',
                'type' => 'warning'
            ]
        ];

        $server_statement = DBManager::get()->prepare("
            SELECT * FROM `check_remote_servers`
        ");
        $server_statement->execute();
        $alarm_insert = DBManager::get()->prepare("
            INSERT INTO `check_remote_servers_alarms`
            SET `metric` = :metric,
                `server_id` = :server_id,
                `type` = :type,
                `value` = :value,
                `compare` = :compare,
                `chdate` = UNIX_TIMESTAMP(),
                `mkdate` = UNIX_TIMESTAMP()
        ");
        while ($server = $server_statement->fetch(PDO::FETCH_ASSOC)) {
            foreach ($alarms as $alarm) {
                $alarm['server_id'] = $server['server_id'];
                $alarm_insert->execute($alarm);
            }
        }
        SimpleORMap::expireTableScheme();
	}

    function down()
    {
        DBManager::get()->exec("
            ALTER TABLE `check_monitoring_data`
            DROP COLUMN `cache`
        ");
        SimpleORMap::expireTableScheme();
    }
}
