<?php
class AddHisinoneSoapCheck extends Migration
{
	function up()
    {
        DBManager::get()->exec("
            ALTER TABLE `check_soap_requests`
            ADD COLUMN `security_header` varchar(20) DEFAULT '' AFTER `params`
        ");

        $insert_request = DBManager::get()->prepare('
            INSERT INTO `check_soap_requests`
            SET `request_id` = :request_id,
                `name` = :name,
                `wsdl` = :wsdl,
                `method` = :method,
                `username` = :username,
                `password` = :password,
                `security_header` = :security_header,
                `params` = :params,
                `necessary_request` = 1,
                `chdate` = UNIX_TIMESTAMP(),
                `mkdate` = UNIX_TIMESTAMP()
        ');
        $fleximport = PluginManager::getInstance()->getPlugin('Fleximport');
        if ($fleximport !== null && FleximportConfig::get('HISINONE_SOAP_ENDPOINT') && FleximportConfig::get('HISINONE_SOAP_USERNAME') && FleximportConfig::get('HISINONE_SOAP_PASSWORD')) {
            $insert_request->execute([
                'request_id' => md5(uniqid()),
                'name' => 'HisInOne',
                'wsdl' => FleximportConfig::get('HISINONE_SOAP_ENDPOINT').'KeyvalueService.wsdl',
                'method' => 'getAllValid',
                'username' => FleximportConfig::get('HISINONE_SOAP_USERNAME'),
                'password' => FleximportConfig::get('HISINONE_SOAP_PASSWORD'),
                'security_header' => 'wsse',
                'params' => '[{"valueClass":"TermTypeValue","lang":"de"}]'
            ]);
        }

        SimpleORMap::expireTableScheme();
	}

    function down()
    {
        DBManager::get()->exec("
            ALTER TABLE `check_soap_requests`
            DROP COLUMN `security_header`
        ");
        SimpleORMap::expireTableScheme();
    }
}
