<div id="dashboard_data">
    <?= $this->render_partial('monitor/_dashboard') ?>
</div>

<audio id="success_sound" src="<?= $plugin->getPluginURL().'/assets/success.mp3' ?>"></audio>
<audio id="error_sound" src="<?= $plugin->getPluginURL().'/assets/error.mp3' ?>"></audio>

<style>
    .maximum {
        font-weight: bold;
    }
</style>

<?

$select_widget = new SelectWidget(
    _('Metrik'),
    PluginEngine::getURL($plugin, [], 'monitor/change_metric'),
    'metric',
    'post'
);
$select_widget->setOptions([
    'users_online' => _('Onlinenutzer'),
    'load_percentage' => _('CPU-Auslastung'),
    'mycourses_time' => _('Meine-VA Zeit')
], UserConfig::get($GLOBALS['user']->id)->CHECK_SELECTED_METRIC);
Sidebar::Get()->addWidget($select_widget);

$viewswidget = new ViewsWidget();
$viewswidget->addLink(
    _('Normale Ansicht'),
    PluginEngine::getURL($plugin, [], 'monitor/dashboard')
)->setActive(Request::option('mode') !== 'kiosk');
$viewswidget->addLink(
    _('Kioskmodus'),
    PluginEngine::getURL($plugin, ['mode' => 'kiosk'], 'monitor/dashboard')
)->setActive(Request::option('mode') === 'kiosk');
Sidebar::Get()->addWidget($viewswidget);

if ($GLOBALS['perm']->have_perm('root')) {
    $actions = new ActionsWidget();

    $actions->addLink(
        sprintf(_("Standorte filtern")),
        PluginEngine::getURL($plugin, array(), "server/filter"),
        Icon::create("filter", "clickable"),
        array('data-dialog' => 1)
    );
    $actions->addLink(
        sprintf(_("TMP-Ordner leeren (%s %s frei)"), $fds_number, $fds_unit),
        PluginEngine::getURL($plugin, array(), "repair/tmp"),
        Icon::create("trash", "clickable"),
        array('onClick' => "return window.confirm('" . _("Wirklich leeren?") . "');")
    );
    $actions->addLink(
        _("SOAP-Abfrage testen"),
        PluginEngine::getURL($plugin, array(), "testsoap/compose"),
        Icon::create($plugin->getPluginURL() . "/assets/soap.svg", "clickable"),
        array('data-dialog' => 1)
    );
    $actions->addLink(
        _("Mail verschicken"),
        PluginEngine::getURL($plugin, array(), "mail/send_mail"),
        Icon::create("mail", "clickable"),
        array('data-dialog' => 1)
    );
    if (ini_get('error_log') || !empty($GLOBALS['ERROR_LOG_PATH'])) {
        $actions->addLink(
            _("Error-Log abrufen"),
            PluginEngine::getURL($plugin, array(), "check/error_log"),
            Icon::create("log", "clickable"),
            array('data-dialog' => 1)
        );
    }
    $actions->addLink(
        _("PHP-Info"),
        PluginEngine::getURL($plugin, array(), "check/phpinfo"),
        Icon::create("infopage", "clickable")
    );
    $actions->addLink(
        _("DB-Query Log"),
        PluginEngine::getURL($plugin, array(), "check/querylog"),
        Icon::create("sport", "clickable"),
        array('data-dialog' => 1)
    );
    $actions->addLink(
        _("JSON-Daten exportieren"),
        PluginEngine::getURL($plugin, array('secret' => md5(Config::get()->STUDIP_INSTALLATION_ID . "Reporter")), "reporter/json/"),
        Icon::create("export", "clickable")
    );
    Sidebar::Get()->addWidget($actions);
}
